function [ ll ] = ll_rclogit( theta , data , mp )
%LL_RCLOGIT Summary of this function goes here
%   Detailed explanation goes here

global fctCount

fctCount = fctCount+1; 

% utilities
v = data.z*reshape(theta,[mp.D,mp.K])*data.x/mp.lambda; 
mxm = max(v,[],2);
logsum = mxm + log(sum(exp(v-mxm(:,ones(1,mp.J))),2));
%logsum = log(sum(exp(v),2)); 

% CCPs
if 0; 
    % Computationally instable method
    ccps = exp(v(data.choiceIdx)')./exp(logsum); 
    ll = log(ccps); 
else 
    % Stable method for the log likelihood
    ll = v(data.choiceIdx)' - logsum; 
end; 


end

